import { Injectable } from '@angular/core';
import { Router, CanActivate, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';



@Injectable()
export class AuthGuard implements CanActivate {

  constructor(private router: Router){}

  canActivate(router: ActivatedRouteSnapshot, state: RouterStateSnapshot) {

    if(localStorage.getItem('currentUser')){
      //logged in so return true
      return true;
    }
// not logged in so redirect to login page with the return url and return false
    this.router.navigate(['login'], {queryParams: { returnUrl: state.url }});
    console.log('i am checking to see if you are logged in');
    return false;
  }

}
